%{
//      GPPGParser,   ,   gppg
    public Parser(AbstractScanner<int, LexLocation> scanner) : base(scanner) { }
%}

%output = SimpleYacc.cs

%namespace SimpleParser

%token BEGIN END CYCLE INUM RNUM ID ASSIGN SEMICOLON WHILE DO REPEAT UNTIL FOR TO WRITE IF ELSE THEN LEFT_PR RIGHT_PR VAR COMMA PLUS MINUS MULT DIVISION

%%

progr   : block
		;

stlist	: statement 
		| stlist SEMICOLON statement 
		;

statement: assign
		| block  
		| cycle
		| while
		| repeat
		| for
		| write
		| if
		| var
		;

ident 	: ID 
		;
	
assign 	: ident ASSIGN expr 
		;

expr	: t  
		| expr PLUS t
		| expr MINUS t
		;

block	: BEGIN stlist END 
		;

cycle	: CYCLE expr statement 
		;
	
while   : WHILE expr DO statement
	    ;

repeat  : REPEAT stlist UNTIL expr
		;

for     : FOR ID ASSIGN expr TO expr DO statement
		;

write   : WRITE LEFT_PR expr RIGHT_PR
		;

if		: IF expr THEN statement ELSE statement
		| IF expr THEN statement
		;

idlist  : ID
		| idlist COMMA ID
		;

var     : VAR idlist
		;

t		: f
		| t MULT f
		| t DIVISION f
		;

f		: ident
		| INUM 
		| LEFT_PR expr RIGHT_PR
		;

%%
