﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;

namespace SimpleLang.Visitors
{
    public class CommonlyUsedVarVisitor : AutoVisitor
    {
        
        public Dictionary<string, int> varUsageCount = new Dictionary<string, int>();
        public string mostCommonlyUsedVar()
        {
            int maxCount = 0;
            string mostCommonVar = "";
            foreach (var kv in varUsageCount)
            {
                if (kv.Value > maxCount)
                {
                    mostCommonVar = kv.Key;
                    maxCount = kv.Value;
                }
            }
            return mostCommonVar;


        }
        public override void VisitIdNode(IdNode id)
        {
            if (!varUsageCount.ContainsKey(id.Name))
                varUsageCount[id.Name] = 0;
            varUsageCount[id.Name]++;
        }

    }
}
