﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;

namespace SimpleLang.Visitors
{
    public class CountCyclesOpVisitor : AutoVisitor
    {
        public int AssignCount = 0;
        public int CyclesCount = 0;
        public int CyclesEntered = 0;
        

        public int MidCount()
        {
           // throw new NotImplementedException();
            return CyclesCount == 0 ? 0 : AssignCount / CyclesCount;
        }
        public override void VisitCycleNode(CycleNode c)
        {
            CyclesCount++;
            CyclesEntered++;
            base.VisitCycleNode(c);
            CyclesEntered--;
        }
        public override void VisitAssignNode(AssignNode a)
        {
            if (CyclesEntered > 0)
                AssignCount++;
            base.VisitAssignNode(a);
        }

		public override void VisitWriteNode(WriteNode a)
		{
			if (CyclesEntered > 0)
				AssignCount++;
			base.VisitWriteNode(a);
		}

		public override void VisitVarDefNode(VarDefNode a)
		{
			if (CyclesEntered > 0)
				AssignCount++;
			base.VisitVarDefNode(a);
		}

	}
}
