﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;

namespace SimpleLang.Visitors
{
    public class ExprComplexityVisitor : AutoVisitor
    {
        List<int> complexityList = new List<int>();
        int lastExprComplexity = 0;

        public override void VisitAssignNode(AssignNode a)
        {
            a.Expr.Visit(this);
            complexityList.Add(lastExprComplexity);
            lastExprComplexity = 0;
        }

        public override void VisitCycleNode(CycleNode c)
        {
            c.Expr.Visit(this);
            complexityList.Add(lastExprComplexity);
            lastExprComplexity = 0;
            c.Stat.Visit(this);
        }

        public override void VisitWriteNode(WriteNode w)
        {
            w.Expr.Visit(this);
            complexityList.Add(lastExprComplexity);
            lastExprComplexity = 0;
        }

        public List<int> getComplexityList()
        {
            return complexityList;
        }

        public override void VisitBinOpNode(BinOpNode binop)
        {
            binop.Left.Visit(this);
            if (binop.Op == '+' || binop.Op == '-')
            {
                lastExprComplexity += 1;
            }
            if (binop.Op == '*' || binop.Op == '/')
            {
                lastExprComplexity += 3;
            }
            binop.Right.Visit(this);
        }



    }
}
