using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;


namespace SimpleLang.Visitors
{
    public class MaxIfCycleNestVisitor : AutoVisitor
    {
        public int MaxNest = 0;
        private int currentNest = 0;
        public override void VisitIfNode(IfNode i)
        {
            currentNest++;
            if (currentNest > MaxNest)
                MaxNest = currentNest;
            base.VisitIfNode(i);
            currentNest--;
        }
        public override void VisitCycleNode(CycleNode c)
        {
            currentNest++;
            if (currentNest > MaxNest)
                MaxNest = currentNest;
            base.VisitCycleNode(c);
            currentNest--;
        }

    }
}